#include "keyboard.h"

input_config config[16]={
             {
              {0,0,0,0,0},

              {KEYBOARD1,NONE,NONE,NONE,NONE},

               {
                {KEY_UP,KEY_DOWN,KEY_LEFT,KEY_RIGHT,KEY_ALT,KEY_SPACE,
                 KEY_TAB,KEY_ENTER,KEY_C,KEY_X},
                {},
                {},
                {},
                {}
                }
              }
             };
// info about the input config

UChar current_config;
// the number of the current config

#define	JOY_A		   0x01
#define	JOY_B		   0x02
#define	JOY_SELECT	0x04
#define	JOY_START	0x08
#define	JOY_UP		0x10
#define	JOY_RIGHT	0x20
#define	JOY_DOWN	   0x40
#define	JOY_LEFT	   0x80

extern int UPeriod;

extern unsigned char nb_joy;

extern unsigned char joy_mapping[5][10];

extern char cart_reload;

char auto_fire_A[5];

char auto_fire_B[5];

char already_fired_A[5]={0,0,0,0,0};
/* Used to know whether the auto fire must set or not the button */

char already_fired_B[5]={0,0,0,0,0};
/* Used to know whether the auto fire must set or not the button */

/* for nothing */
UInt16 noinput()
 {
  return 0;
  }

/* for keyboard */
UInt16 keyboard1()
{
 UInt16 tmp=0;

	  if (key[config[current_config].joy_mapping[0][J_DOWN]])
		 tmp|=JOY_DOWN;
     else
	    if (key[config[current_config].joy_mapping[0][J_UP]])
		   tmp|=JOY_UP;

     if (key[config[current_config].joy_mapping[0][J_LEFT]])
		 tmp|=JOY_LEFT;
     else
       if (key[config[current_config].joy_mapping[0][J_RIGHT]])
		   tmp|=JOY_RIGHT;

     if (key[config[current_config].joy_mapping[0][J_II]])
		 if (!auto_fire_A[0])
		   tmp|=JOY_A;
       else
			{
 			  already_fired_A[0]=!already_fired_A[0];
			  if (!already_fired_A[0])
				 tmp|=JOY_A;
			 }

     if (key[config[current_config].joy_mapping[0][J_I]])
		 if (!auto_fire_B[0])
		   tmp|=JOY_B;
       else
			{
 			  already_fired_B[0]=!already_fired_B[0];
			  if (!already_fired_B[0])
				 tmp|=JOY_B;
			 }

     if (key[config[current_config].joy_mapping[0][J_SELECT]])
		 tmp|=JOY_SELECT;

     if (key[config[current_config].joy_mapping[0][J_START]])
		 tmp|=JOY_START;

     if (key[config[current_config].joy_mapping[0][J_AUTOI]])
		 if (!key_delay)
			{
		     auto_fire_A[0]=!auto_fire_A[0];
			  key_delay=10;
         }

     if (key[config[current_config].joy_mapping[0][J_AUTOII]])
		 if (!key_delay)
			{
		     auto_fire_B[0]=!auto_fire_B[0];
			  key_delay=10;
         }

 return tmp;
 }

UInt16 keyboard2()
{
 UInt16 tmp=0;

	  if (key[config[current_config].joy_mapping[1][J_DOWN]])
		 tmp|=JOY_DOWN;
     else
	    if (key[config[current_config].joy_mapping[1][J_UP]])
		   tmp|=JOY_UP;

     if (key[config[current_config].joy_mapping[1][J_LEFT]])
		 tmp|=JOY_LEFT;
     else
       if (key[config[current_config].joy_mapping[1][J_RIGHT]])
		   tmp|=JOY_RIGHT;

     if (key[config[current_config].joy_mapping[1][J_II]])
		 if (!auto_fire_A[1])
		   tmp|=JOY_A;
       else
			{
 			  already_fired_A[1]=!already_fired_A[1];
			  if (!already_fired_A[1])
				 tmp|=JOY_A;
			 }

     if (key[config[current_config].joy_mapping[1][J_I]])
		 if (!auto_fire_B[1])
		   tmp|=JOY_B;
       else
			{
 			  already_fired_B[1]=!already_fired_B[1];
			  if (!already_fired_B[1])
				 tmp|=JOY_B;
			 }

     if (key[config[current_config].joy_mapping[1][J_SELECT]])
		 tmp|=JOY_SELECT;

     if (key[config[current_config].joy_mapping[1][J_START]])
		 tmp|=JOY_START;

     if (key[config[current_config].joy_mapping[1][J_AUTOI]])
		 if (!key_delay)
			{
		     auto_fire_A[1]=!auto_fire_A[1];
			  key_delay=10;
         }

     if (key[config[current_config].joy_mapping[1][J_AUTOII]])
		 if (!key_delay)
			{
		     auto_fire_B[1]=!auto_fire_B[1];
			  key_delay=10;
         }

 return tmp;
 }
UInt16 keyboard3()
{
 UInt16 tmp=0;

	  if (key[config[current_config].joy_mapping[2][J_DOWN]])
		 tmp|=JOY_DOWN;
     else
	    if (key[config[current_config].joy_mapping[2][J_UP]])
		   tmp|=JOY_UP;

     if (key[config[current_config].joy_mapping[2][J_LEFT]])
		 tmp|=JOY_LEFT;
     else
       if (key[config[current_config].joy_mapping[2][J_RIGHT]])
		   tmp|=JOY_RIGHT;

     if (key[config[current_config].joy_mapping[2][J_II]])
		 if (!auto_fire_A[2])
		   tmp|=JOY_A;
       else
			{
 			  already_fired_A[2]=!already_fired_A[2];
			  if (!already_fired_A[2])
				 tmp|=JOY_A;
			 }

     if (key[config[current_config].joy_mapping[2][J_I]])
		 if (!auto_fire_B[2])
		   tmp|=JOY_B;
       else
			{
 			  already_fired_B[2]=!already_fired_B[2];
			  if (!already_fired_B[2])
				 tmp|=JOY_B;
			 }

     if (key[config[current_config].joy_mapping[2][J_SELECT]])
		 tmp|=JOY_SELECT;

     if (key[config[current_config].joy_mapping[2][J_START]])
		 tmp|=JOY_START;

     if (key[config[current_config].joy_mapping[2][J_AUTOI]])
		 if (!key_delay)
			{
		     auto_fire_A[2]=!auto_fire_A[2];
			  key_delay=10;
         }

     if (key[config[current_config].joy_mapping[2][J_AUTOII]])
		 if (!key_delay)
			{
		     auto_fire_B[2]=!auto_fire_B[2];
			  key_delay=10;
         }

 return tmp;
 }

UInt16 keyboard4()
{
 UInt16 tmp=0;

	  if (key[config[current_config].joy_mapping[3][J_DOWN]])
		 tmp|=JOY_DOWN;
     else
	    if (key[config[current_config].joy_mapping[3][J_UP]])
		   tmp|=JOY_UP;

     if (key[config[current_config].joy_mapping[3][J_LEFT]])
		 tmp|=JOY_LEFT;
     else
       if (key[config[current_config].joy_mapping[3][J_RIGHT]])
		   tmp|=JOY_RIGHT;

     if (key[config[current_config].joy_mapping[3][J_II]])
		 if (!auto_fire_A[3])
		   tmp|=JOY_A;
       else
			{
 			  already_fired_A[3]=!already_fired_A[3];
			  if (!already_fired_A[3])
				 tmp|=JOY_A;
			 }

     if (key[config[current_config].joy_mapping[3][J_I]])
		 if (!auto_fire_B[3])
		   tmp|=JOY_B;
       else
			{
 			  already_fired_B[3]=!already_fired_B[3];
			  if (!already_fired_B[3])
				 tmp|=JOY_B;
			 }

     if (key[config[current_config].joy_mapping[3][J_SELECT]])
		 tmp|=JOY_SELECT;

     if (key[config[current_config].joy_mapping[3][J_START]])
		 tmp|=JOY_START;

     if (key[config[current_config].joy_mapping[3][J_AUTOI]])
		 if (!key_delay)
			{
		     auto_fire_A[3]=!auto_fire_A[3];
			  key_delay=10;
         }

     if (key[config[current_config].joy_mapping[3][J_AUTOII]])
		 if (!key_delay)
			{
		     auto_fire_B[3]=!auto_fire_B[3];
			  key_delay=10;
         }

 return tmp;
 }

UInt16 keyboard5()
{
 UInt16 tmp=0;

	  if (key[config[current_config].joy_mapping[4][J_DOWN]])
		 tmp|=JOY_DOWN;
     else
	    if (key[config[current_config].joy_mapping[4][J_UP]])
		   tmp|=JOY_UP;

     if (key[config[current_config].joy_mapping[4][J_LEFT]])
		 tmp|=JOY_LEFT;
     else
       if (key[config[current_config].joy_mapping[4][J_RIGHT]])
		   tmp|=JOY_RIGHT;

     if (key[config[current_config].joy_mapping[4][J_II]])
		 if (!auto_fire_A[4])
		   tmp|=JOY_A;
       else
			{
 			  already_fired_A[4]=!already_fired_A[4];
			  if (!already_fired_A[4])
				 tmp|=JOY_A;
			 }

     if (key[config[current_config].joy_mapping[4][J_I]])
		 if (!auto_fire_B[4])
		   tmp|=JOY_B;
       else
			{
 			  already_fired_B[4]=!already_fired_B[4];
			  if (!already_fired_B[4])
				 tmp|=JOY_B;
			 }

     if (key[config[current_config].joy_mapping[4][J_SELECT]])
		 tmp|=JOY_SELECT;

     if (key[config[current_config].joy_mapping[4][J_START]])
		 tmp|=JOY_START;

     if (key[config[current_config].joy_mapping[4][J_AUTOI]])
		 if (!key_delay)
			{
		     auto_fire_A[4]=!auto_fire_A[4];
			  key_delay=10;
         }

     if (key[config[current_config].joy_mapping[4][J_AUTOII]])
		 if (!key_delay)
			{
		     auto_fire_B[4]=!auto_fire_B[4];
			  key_delay=10;
         }

 return tmp;
 }

/* for joypad */
UInt16 joypad1()
 {
  UInt16 tmp;

  poll_joystick();

  tmp=0;

	 if (joy[0].stick[0].axis[0].d1)
		tmp|=JOY_LEFT;

    if (joy[0].stick[0].axis[0].d2)
		tmp|=JOY_RIGHT;

	 if (joy[0].stick[0].axis[1].d1)
		tmp|=JOY_UP;

    if (joy[0].stick[0].axis[1].d2)
		tmp|=JOY_DOWN;

    if (joy[0].button[0].b)
		tmp|=JOY_A;

    if (joy[0].button[1].b)
		tmp|=JOY_B;

	 if (key[config[current_config].joy_mapping[0][J_START]])
		tmp|=JOY_START;

    if (key[config[current_config].joy_mapping[0][J_SELECT]])
		tmp|=JOY_SELECT;

  return tmp;
  }

UInt16 joypad2()
 {
  return 0;
  }

UInt16 joypad3()
 {
  return 0;
  }

UInt16 joypad4()
 {
  return 0;
  }

/* for mouse */
UInt16 mouse1()
 {
  return 0;
  }

UInt16 mouse2()
 {
  return 0;
  }

/* for synaptic link */
UInt16 synaplink()
 {
  return 0;
  }


int Joysticks(void)
{
 char tmp_joy;

 while (key[KEY_PAUSE]) pause();

 if(( key[KEY_ASTERISK]) && (!key_delay))
	{
	  disass_menu();
	  key_delay=10;
   }

 if(( key[KEY_ESC] ) && (!key_delay))
	{
     //menu(); //There will be the GUI
	  while (keypressed())
		 readkey();
	  select_rom("*.pce");
	  while (keypressed())
		 readkey();
     key_delay=10;

	  if (!strcmp("TRUE EXIT",selected_rom))
		 {
		   cart_reload=0;
			return 1;
       }

	  if (strcmp("NO FILE",selected_rom))
		 {
		   cart_reload=1;
			strcpy(cart_name,selected_rom);
			return 1;
       }

   }
 if( key[KEY_F12] )
	return 1;
 if( key[KEY_F6] )
   {
	  if (!silent)
		 {
//	      AGetVoiceVolume(hVoice,&vol);
//	      ASetVoiceVolume(hVoice,0);
			AStopVoice(hVoice);
			lpWave->dwLoopEnd=0;
			ASetVoicePosition(hVoice,0);
			AUpdateAudio();
       }
     if (!savegame());
       set_message(MESSAGE[language][game_save]);
     message_delay=180;

	  if (!silent)
		 {
//     	  ASetVoiceVolume(hVoice,vol);
			lpWave->dwLoopEnd=lpWave->dwLength;
			ASetVoicePosition(hVoice,0);

		  AStartVoice(hVoice);

		  AUpdateAudio();

       }

   };
 if( key[KEY_F7] )
   {
     if (!loadgame());
       set_message(MESSAGE[language][game_load]);
     message_delay=180;
   };
 if( key[KEY_F5] )
   if (!key_delay)
     {
		 char* tmp_buf=(char*)alloca(100);
       sprintf(tmp_buf,MESSAGE[language][screen_shot],savepict());
       set_message(tmp_buf);
       message_delay=180;
       key_delay=10;
     };
 if( key[KEY_F1] )
  {
   searchbyte();
	return 0;
  }
 if( key[KEY_F2] )
  {
   pokebyte();
	return 0;
  }
 if( key[KEY_F3] )
  {
	 freeze_value();
	 return 0;
   }
 if( key[KEY_F10])
    if (!key_delay)
      {
        synchro=!synchro;
        set_message(MESSAGE[language][full_speed+synchro]);
        message_delay=180;
        key_delay=10;
      };
 if( key[KEY_NUMLOCK])
	if (!key_delay)
	  {
		if (dump_snd)
		  {
			fclose(out_snd);
			set_message(MESSAGE[language][dump_off]);
			}
      else
		  {
			unsigned	short tmp=0;
			char tmp_buf[128]="SND0000.PCM";

			while ((tmp<0xFFFF) && (exists(tmp_buf)))
			  sprintf(tmp_buf,"SND%04X.PCM",++tmp);

			out_snd=fopen(tmp_buf,"wb");
			set_message(MESSAGE[language][dump_on]);
			}
      dump_snd=!dump_snd;
		key_delay=10;
		message_delay=180;
		}
 if( key[KEY_PLUS_PAD])
    if (!key_delay)
      {
        if (UPeriod<15)
          {
			   char* tmp_buf=(char*)alloca(100);
            UPeriod++;
				sprintf(tmp_buf,MESSAGE[language][frame_skip],UPeriod);
            set_message(tmp_buf);
            message_delay=180;
          };
        key_delay=10;
      };
 if( key[KEY_MINUS_PAD])
    if (!key_delay)
      {
        if (UPeriod)
          {
            UPeriod--;
				if (!UPeriod)
              set_message(MESSAGE[language][all_frame]);
            else
				  {
					 char* tmp_buf=(char*)alloca(100);
				    sprintf(tmp_buf,MESSAGE[language][frame_skip],UPeriod);
					 set_message(tmp_buf);
              };
            message_delay=180;
          };
        key_delay=10;
      };

  if ((key[KEY_1]) && (!key_delay))
	 {
	   SPONSwitch=!SPONSwitch;
		key_delay=10;
    }
  if ((key[KEY_2]) && (!key_delay))
	 {
	   BGONSwitch=!BGONSwitch;
		key_delay=10;
    }

 io.JOY[0]=(*config[current_config].pad[0])();
 io.JOY[1]=(*config[current_config].pad[1])();
 io.JOY[2]=(*config[current_config].pad[2])();
 io.JOY[3]=(*config[current_config].pad[3])();
 io.JOY[4]=(*config[current_config].pad[4])();
 /*poll_joystick();

 {
UInt16 tmp=0;
	 if (joy[0].stick[0].axis[0].d1)
		tmp|=JOY_LEFT;

    if (joy[0].stick[0].axis[0].d2)
		tmp|=JOY_RIGHT;

	 if (joy[0].stick[0].axis[1].d1)
		tmp|=JOY_UP;

    if (joy[0].stick[0].axis[1].d2)
		tmp|=JOY_DOWN;

    if (joy[0].button[0].b)
		tmp|=JOY_A;

    if (joy[0].button[1].b)
		tmp|=JOY_B;

    if (key[KEY_ENTER])
      tmp|=JOY_START;

        io.JOY[0]=tmp;
  }
   */
/*
 for (tmp_joy=0;tmp_joy<nb_joy ;tmp_joy++ )
    {
	  io.JOY[tmp_joy]=0;

	  if (key[joy_mapping[tmp_joy][J_DOWN]])
		 io.JOY[tmp_joy]|=JOY_DOWN;
     else
	    if (key[joy_mapping[tmp_joy][J_UP]])
		   io.JOY[tmp_joy]|=JOY_UP;

     if (key[joy_mapping[tmp_joy][J_LEFT]])
		 io.JOY[tmp_joy]|=JOY_LEFT;
     else
       if (key[joy_mapping[tmp_joy][J_RIGHT]])
		   io.JOY[tmp_joy]|=JOY_RIGHT;

     if (key[joy_mapping[tmp_joy][J_II]])
		 if (!auto_fire_A[tmp_joy])
		   io.JOY[tmp_joy]|=JOY_A;
       else
			{
 			  already_fired_A[tmp_joy]=!already_fired_A[tmp_joy];
			  if (!already_fired_A[tmp_joy])
				 io.JOY[tmp_joy]|=JOY_A;
			 }

     if (key[joy_mapping[tmp_joy][J_I]])
		 if (!auto_fire_B[tmp_joy])
		   io.JOY[tmp_joy]|=JOY_B;
       else
			{
 			  already_fired_B[tmp_joy]=!already_fired_B[tmp_joy];
			  if (!already_fired_B[tmp_joy])
				 io.JOY[tmp_joy]|=JOY_B;
			 }

     if (key[joy_mapping[tmp_joy][J_SELECT]])
		 io.JOY[tmp_joy]|=JOY_SELECT;

     if (key[joy_mapping[tmp_joy][J_START]])
		 io.JOY[tmp_joy]|=JOY_START;

     if (key[joy_mapping[tmp_joy][J_AUTOI]])
		 if (!key_delay)
			{
		     auto_fire_A[tmp_joy]=!auto_fire_A[tmp_joy];
			  key_delay=10;
         }

     if (key[joy_mapping[tmp_joy][J_AUTOII]])
		 if (!key_delay)
			{
		     auto_fire_B[tmp_joy]=!auto_fire_B[tmp_joy];
			  key_delay=10;
         }


    }
  */
 //return JS;
 return 0;
}